Weather - Get Weather Along Route

Use to get a locationally precise, up-to-the-minute forecast that includes weather hazard assessments and notifications along a route.
The Get Weather Along Route API is an HTTP GET request that returns hyper local (one kilometer or less), up-to-the-minute weather nowcasts, weather hazard assessments, and notifications along a route described as a sequence of waypoints. This includes a list of weather hazards affecting the waypoint or route, and the aggregated hazard index for each waypoint might be used to paint each portion of a route according to how safe it is for the driver. When submitting the waypoints, it is recommended to stay within, or close to, the distance that can be traveled within 120-mins or shortly after. Data is updated every five minutes.

The service supplements Azure Maps Route Service that allows you to first request a route between an origin and a destination and use that as an input for Weather Along Route endpoint.

In addition, the service supports scenarios to generate weather notifications for waypoints that experience an increase in intensity of a weather hazard. For example, if the vehicle is expected to begin experiencing heavy rain as it reaches a waypoint, a weather notification for heavy rain will be generated for that waypoint allowing the end product to display a heavy rain notification before the driver reaches that waypoint. The trigger for when to display the notification for a waypoint could be based, for example, on a geofence, or selectable distance to the waypoint.

The API covers all regions of the planet except latitudes above Greenland and Antarctica.

GET {endpoint}/weather/route/json?api-version=1.1&query={query}
GET {endpoint}/weather/route/json?api-version=1.1&query={query}&language={language}

URI Parameters

Name In Required Type Description
endpoint
path True

string (uri)

The Azure Maps service hostname. Use https://atlas.microsoft.com for the Azure public cloud. To target a specific Azure Maps geography or a sovereign cloud, see Azure Maps geographic scope.

format
path True

JsonFormat

Desired format of the response. Only json format is supported.

api-version
query True

string

minLength: 1

The API version to use for this operation.

query
query True

string

Coordinates through which the route is calculated, separated by colon (:) and entered in chronological order. A minimum of two waypoints is required. A single API call may contain up to 60 waypoints. A waypoint indicates location, ETA, and optional heading: latitude,longitude,ETA,heading, where

  • Latitude - Latitude coordinate in decimal degrees.
  • Longitude - Longitude coordinate in decimal degrees.
  • ETA (estimated time of arrival) - The number of minutes from the present time that it will take for the vehicle to reach the waypoint. Allowed range is from 0.0 to 120.0 minutes.
  • Heading - An optional value indicating the vehicle heading as it passes the waypoint. Expressed in clockwise degrees relative to true north. This is issued to calculate sun glare as a driving hazard. Allowed range is from 0.0 to 360.0 degrees. If not provided, a heading will automatically be derived based on the position of neighboring waypoints.

It is recommended to stay within, or close to, the distance that can be traveled within 120-mins or shortly after. This way a more accurate assessment can be provided for the trip and prevent isolated events not being captured between waypoints. Information can and should be updated along the route (especially for trips greater than 2 hours) to continuously pull new waypoints moving forward, but also to ensure that forecast information for content such as precipitation type and intensity is accurate as storms develop and dissipate over time.

language
query

string

Language in which search results should be returned. Should be one of supported IETF language tags, case insensitive. When data in specified language is not available for a specific field, default language is used.

Please refer to Supported Languages for details.

Request Header

Name Required Type Description
x-ms-client-id

string

Indicates the account intended for use with the Microsoft Entra ID security model. This unique ID for the Azure Maps account can be obtained from the Azure Maps management plane Account API. For more information on using Microsoft Entra ID security in Azure Maps, see Manage authentication in Azure Maps.

Responses

Name Type Description
200 OK

WeatherAlongRouteResult

The request has succeeded.

Other Status Codes

ErrorResponse

An unexpected error response.

Security

AadToken

These are the Microsoft Entra OAuth 2.0 Flows. When paired with Azure role-based access control it can be used to control access to Azure Maps REST APIs. Azure role-based access controls are used to designate access to one or more Azure Maps resource account or sub-resources. Any user, group, or service principal can be granted access via a built-in role or a custom role composed of one or more permissions to Azure Maps REST APIs.

To implement scenarios, we recommend viewing authentication concepts. In summary, this security definition provides a solution for modeling application(s) via objects capable of access control on specific APIs and scopes.

Note

  • This security definition requires the use of the x-ms-client-id header to indicate which Azure Maps resource the application is requesting access to. This can be acquired from the Maps management API.
  • The Authorization URL is specific to the Azure public cloud instance. Sovereign clouds have unique Authorization URLs and Microsoft Entra ID configurations.
  • The Azure role-based access control is configured from the Azure management plane via Azure portal, PowerShell, CLI, Azure SDKs, or REST APIs.
  • Usage of the Azure Maps Web SDK allows for configuration based setup of an application for multiple use cases.
  • For more information on Microsoft identity platform, see Microsoft identity platform overview.

Type: oauth2
Flow: implicit
Authorization URL: https://login.microsoftonline.com/common/oauth2/authorize

Scopes

Name Description
https://atlas.microsoft.com/.default

subscription-key

This is a shared key that is provisioned when you Create an Azure Maps account in the Azure portal or using PowerShell, CLI, Azure SDKs, or REST API.

With this key, any application can access all REST API. In other words, this key can be used as a master key in the account that they are issued in.

For publicly exposed applications, our recommendation is to use the confidential client applications approach to access Azure Maps REST APIs so your key can be securely stored.

Type: apiKey
In: header

SAS Token

This is a shared access signature token is created from the List SAS operation on the Azure Maps resource through the Azure management plane via Azure portal, PowerShell, CLI, Azure SDKs, or REST APIs.

With this token, any application is authorized to access with Azure role-based access controls and fine-grain control to the expiration, rate, and region(s) of use for the particular token. In other words, the SAS Token can be used to allow applications to control access in a more secured way than the shared key.

For publicly exposed applications, our recommendation is to configure a specific list of allowed origins on the Map account resource to limit rendering abuse and regularly renew the SAS Token.

Type: apiKey
In: header

Examples

Successfully retrieve detailed weather casts along a route described as a sequence of waypoints

Sample request

GET https://atlas.microsoft.com/weather/route/json?api-version=1.1&query=38.907,-77.037,0:38.907,-77.009,10:38.926,-76.928,20:39.033,-76.852,30:39.168,-76.732,40:39.269,-76.634,50:39.287,-76.612,60

Sample response

{
  "summary": {
    "hazards": {
      "maxHazardIndex": 0
    },
    "iconCode": 35
  },
  "waypoints": [
    {
      "cloudCover": 70,
      "hazards": {
        "maxHazardIndex": 0
      },
      "iconCode": 38,
      "isDayTime": false,
      "lightningCount": 0,
      "notifications": [],
      "precipitation": {
        "type": "SNOW",
        "dbz": 0
      },
      "shortPhrase": "Mostly cloudy",
      "sunGlare": {
        "calculatedVehicleHeading": 90,
        "glareIndex": 0
      },
      "temperature": {
        "unit": "C",
        "unitType": 17,
        "value": 3.4
      },
      "wind": {
        "direction": {
          "degrees": 142
        },
        "speed": {
          "unit": "km/h",
          "unitType": 7,
          "value": 2
        }
      },
      "windGust": {
        "speed": {
          "unit": "km/h",
          "unitType": 7,
          "value": 3
        }
      }
    },
    {
      "cloudCover": 65,
      "hazards": {
        "maxHazardIndex": 0
      },
      "iconCode": 38,
      "isDayTime": false,
      "lightningCount": 0,
      "notifications": [],
      "precipitation": {
        "type": "SNOW",
        "dbz": 0
      },
      "shortPhrase": "Mostly cloudy",
      "sunGlare": {
        "calculatedVehicleHeading": 77,
        "glareIndex": 0
      },
      "temperature": {
        "unit": "C",
        "unitType": 17,
        "value": 3.4
      },
      "wind": {
        "direction": {
          "degrees": 166
        },
        "speed": {
          "unit": "km/h",
          "unitType": 7,
          "value": 1
        }
      },
      "windGust": {
        "speed": {
          "unit": "km/h",
          "unitType": 7,
          "value": 2
        }
      }
    },
    {
      "cloudCover": 43,
      "hazards": {
        "maxHazardIndex": 0
      },
      "iconCode": 35,
      "isDayTime": false,
      "lightningCount": 0,
      "notifications": [],
      "precipitation": {
        "type": "SNOW",
        "dbz": 0
      },
      "shortPhrase": "Partly cloudy",
      "sunGlare": {
        "calculatedVehicleHeading": 44,
        "glareIndex": 0
      },
      "temperature": {
        "unit": "C",
        "unitType": 17,
        "value": 3.2
      },
      "wind": {
        "direction": {
          "degrees": 163
        },
        "speed": {
          "unit": "km/h",
          "unitType": 7,
          "value": 2
        }
      },
      "windGust": {
        "speed": {
          "unit": "km/h",
          "unitType": 7,
          "value": 2
        }
      }
    },
    {
      "cloudCover": 34,
      "hazards": {
        "maxHazardIndex": 0
      },
      "iconCode": 35,
      "isDayTime": false,
      "lightningCount": 0,
      "notifications": [],
      "precipitation": {
        "type": "SNOW",
        "dbz": 0
      },
      "shortPhrase": "Partly cloudy",
      "sunGlare": {
        "calculatedVehicleHeading": 32,
        "glareIndex": 0
      },
      "temperature": {
        "unit": "C",
        "unitType": 17,
        "value": 1.6
      },
      "wind": {
        "direction": {
          "degrees": 189
        },
        "speed": {
          "unit": "km/h",
          "unitType": 7,
          "value": 2
        }
      },
      "windGust": {
        "speed": {
          "unit": "km/h",
          "unitType": 7,
          "value": 4
        }
      }
    },
    {
      "cloudCover": 54,
      "hazards": {
        "maxHazardIndex": 0
      },
      "iconCode": 38,
      "isDayTime": false,
      "lightningCount": 0,
      "notifications": [],
      "precipitation": {
        "type": "SNOW",
        "dbz": 0
      },
      "shortPhrase": "Mostly cloudy",
      "sunGlare": {
        "calculatedVehicleHeading": 36,
        "glareIndex": 0
      },
      "temperature": {
        "unit": "C",
        "unitType": 17,
        "value": 0.5
      },
      "wind": {
        "direction": {
          "degrees": 202
        },
        "speed": {
          "unit": "km/h",
          "unitType": 7,
          "value": 4
        }
      },
      "windGust": {
        "speed": {
          "unit": "km/h",
          "unitType": 7,
          "value": 5
        }
      }
    },
    {
      "cloudCover": 46,
      "hazards": {
        "maxHazardIndex": 0
      },
      "iconCode": 35,
      "isDayTime": false,
      "lightningCount": 0,
      "notifications": [],
      "precipitation": {
        "type": "SNOW",
        "dbz": 0
      },
      "shortPhrase": "Partly cloudy",
      "sunGlare": {
        "calculatedVehicleHeading": 38,
        "glareIndex": 0
      },
      "temperature": {
        "unit": "C",
        "unitType": 17,
        "value": 2.4
      },
      "wind": {
        "direction": {
          "degrees": 222
        },
        "speed": {
          "unit": "km/h",
          "unitType": 7,
          "value": 4
        }
      },
      "windGust": {
        "speed": {
          "unit": "km/h",
          "unitType": 7,
          "value": 5
        }
      }
    },
    {
      "cloudCover": 39,
      "hazards": {
        "maxHazardIndex": 0
      },
      "iconCode": 35,
      "isDayTime": false,
      "lightningCount": 0,
      "notifications": [],
      "precipitation": {
        "type": "SNOW",
        "dbz": 0
      },
      "shortPhrase": "Partly cloudy",
      "sunGlare": {
        "calculatedVehicleHeading": 43,
        "glareIndex": 0
      },
      "temperature": {
        "unit": "C",
        "unitType": 17,
        "value": 2.3
      },
      "wind": {
        "direction": {
          "degrees": 231
        },
        "speed": {
          "unit": "km/h",
          "unitType": 7,
          "value": 4
        }
      },
      "windGust": {
        "speed": {
          "unit": "km/h",
          "unitType": 7,
          "value": 5
        }
      }
    }
  ]
}

Definitions

Name Description
ErrorAdditionalInfo

The resource management error additional info.

ErrorDetail

The error detail.

ErrorResponse

Common error response for all Azure Resource Manager APIs to return error details for failed operations. (This also follows the OData error response format.).

HazardDetail

One entry in WeatherHazards.hazardDetails describing a single weather hazard at the location (route-level when carried on WeatherAlongRouteSummary.hazards, or per-waypoint when carried on WaypointForecast.hazards). Combines a hazardCode identifying the specific hazard type, a hazardIndex rating its individual severity on the 0-4 scale, and a shortPhrase suitable for display in a UI.

HazardIndex

The aggregated severity/hazard index for each waypoint can be utilized to color-code segments of a route, indicating the safety level for drivers.

  • 0: No hazard
  • 1: Be informed, be aware
  • 2: Pay attention, be prepared
  • 3: Take action
  • 4: Life-threatening, emergency
IconCode

The numeric weather-condition code that identifies which icon to display. Each value in this enumeration corresponds to an Azure Maps weather icon (such as Sunny, Cloudy, or Thunderstorms) and pairs with a human-readable iconPhrase returned alongside it. The same code can appear in current, hourly, daily, quarter-day, and minute-by-minute responses, allowing applications to render a consistent icon set across all weather services.

For the complete list of codes, the icons they map to, and example imagery, see Weather services in Azure Maps.

JsonFormat

Desired format of the response. Only json format is supported.

SunGlare

The sun-glare driving hazard at a single waypoint, returned as WaypointForecast.sunGlare. Reports a glareIndex from 0 to 100 measuring the intensity of glare a driver would experience at the waypoint, together with the calculatedVehicleHeading used to compute it - the heading is either the value supplied for the waypoint in the request or, if none was supplied, one inferred from the neighboring waypoints.

UnitType

An integer value associated with the type of unit being displayed. For example, 17 for Celsius, 18 for Fahrenheit. Can be used for unit translation. For more information, see Weather services in Azure Maps.

WaypointForecast

The detailed forecast for one waypoint along a road route, returned as one entry per requested waypoint in WeatherAlongRouteResult.waypoints (same order as the waypoints supplied in the request). Reports the conditions at that location: a representative iconCode and shortPhrase, whether it is day or night, cloud cover, temperature, wind and wind-gust details, precipitation type and intensity, a lightning-strike count, the sun glare hazard for the driver, the WeatherHazards aggregated at the waypoint, and any free-form hazard notifications.

WeatherAlongRoutePrecipitation

The expected precipitation at a single waypoint along the route, returned as WaypointForecast.precipitation. Reports the forecast intensity as radar reflectivity (dbz) together with the precipitation type (rain, snow, ice, hail, or mix). A dbz of 0 indicates no precipitation, in which case type may still be returned to indicate the precipitation type that would occur if any fell at the waypoint (for example, snow during cold weather).

WeatherAlongRouteResult

The response returned by the Get Weather Along Route operation, providing the forecast for a sequence of waypoints along a road route. Includes a top-level summary with the highest hazard index across the route and a representative weather icon, plus a waypoints array containing one detailed forecast per requested waypoint - cloud cover, temperature, wind, precipitation, lightning count, sun glare, hazards, and notifications.

WeatherAlongRouteSummary

The route-level summary on WeatherAlongRouteResult.summary, giving a single high-level snapshot of conditions across the entire route. Includes a representative weather iconCode for the route and an aggregated hazards block reporting the maximum hazard index and the specific hazard types encountered at any waypoint. Use this when a single route-level indicator is needed; for per-waypoint detail, use WeatherAlongRouteResult.waypoints.

WeatherHazards

A summary of the significant weather hazards at a single location. The same shape is used in two places by the Get Weather Along Route response: on WeatherAlongRouteSummary.hazards, where it aggregates across the entire route (max severity at any waypoint), and on WaypointForecast.hazards, where it describes the hazards at one specific waypoint. Conveys both a top-level maxHazardIndex rating the worst hazard in scope (from 0 - no hazard - to 4 - life-threatening) and a hazardDetails array enumerating each specific hazard type encountered (rain, snow, ice, hail, sun glare, lightning, wind, and severe weather warnings such as floods, tornadoes, tsunamis, and severe thunderstorms).

WeatherNotification

One free-form hazard notification raised at a single waypoint along the route, returned as an entry in WaypointForecast.notifications. Each notification combines a type classifying the notification, a hazardCode identifying the specific hazard, a hazardIndex rating its severity on the 0-4 scale, and a shortPhrase suitable for display. Notifications complement WaypointForecast.hazards - the latter enumerates every active hazard at the waypoint, while notifications carries only the ones the service has flagged as worth surfacing to the driver.

WeatherValue

Values for weather-related metrics such as temperature, dew point, and wind speed, presented in either metric or imperial units, as specified in the unit URI parameter. For more information, see Unit types in the article Weather services in Azure Maps.

WindDetails

Provides the forecasted wind speed, measured in units such as kilometers per hour (km/h) or miles per hour (mph), depending on the unit specified in the request. Also indicates the wind direction measured in azimuth degrees, starting at true North and moving clockwise. North corresponds to 0°, east to 90°, south to 180°, and west to 270°. Possible values range from 0° to 359°.

WindDirection

Provides details about wind direction, including the direction in azimuth degrees and a localized abbreviation of the wind direction.

ErrorAdditionalInfo

The resource management error additional info.

Name Type Description
info

maps.weather.getweatheralongroute

The additional info.

type

string

The additional info type.

ErrorDetail

The error detail.

Name Type Description
additionalInfo

ErrorAdditionalInfo[]

The error additional info.

code

string

The error code.

details

ErrorDetail[]

The error details.

message

string

The error message.

target

string

The error target.

ErrorResponse

Common error response for all Azure Resource Manager APIs to return error details for failed operations. (This also follows the OData error response format.).

Name Type Description
error

ErrorDetail

The error object.

HazardDetail

One entry in WeatherHazards.hazardDetails describing a single weather hazard at the location (route-level when carried on WeatherAlongRouteSummary.hazards, or per-waypoint when carried on WaypointForecast.hazards). Combines a hazardCode identifying the specific hazard type, a hazardIndex rating its individual severity on the 0-4 scale, and a shortPhrase suitable for display in a UI.

Name Type Description
hazardCode

string

A language-independent code identifying the type of hazard. Supported values:

  • LightRain, ModerateRain, HeavyRain
  • LightMix, ModerateMix, HeavyMix
  • LightSnow, ModerateSnow, HeavySnow
  • LightIce, ModerateIce, HeavyIce
  • Hail, LargeHail
  • SunGlare, SunGlareHigh
  • Lightning, SevereLightning
  • WindModerate, WindHigh, WindExtreme
  • FloodWarning, FlashFloodWarning
  • TornadoWarning, TsunamiWarning
  • SevereThunderstormWarning
hazardIndex

HazardIndex

The severity rating for this specific hazard, on the same 0-4 scale as WeatherHazards.maxHazardIndex:

  • 0: No hazard
  • 1: Be informed, be aware
  • 2: Pay attention, be prepared
  • 3: Take action
  • 4: Life-threatening, emergency
shortPhrase

string

A short, displayable phrase describing the hazard, returned in the language specified in the request. Up to 25 characters.

HazardIndex

The aggregated severity/hazard index for each waypoint can be utilized to color-code segments of a route, indicating the safety level for drivers.

  • 0: No hazard
  • 1: Be informed, be aware
  • 2: Pay attention, be prepared
  • 3: Take action
  • 4: Life-threatening, emergency
Value Description
0

No hazard

1

Be informed

2

Pay attention

3

Take action

4

Emergency

IconCode

The numeric weather-condition code that identifies which icon to display. Each value in this enumeration corresponds to an Azure Maps weather icon (such as Sunny, Cloudy, or Thunderstorms) and pairs with a human-readable iconPhrase returned alongside it. The same code can appear in current, hourly, daily, quarter-day, and minute-by-minute responses, allowing applications to render a consistent icon set across all weather services.

For the complete list of codes, the icons they map to, and example imagery, see Weather services in Azure Maps.

Value Description
1

Sunny

2

Mostly Sunny

3

Partly Sunny

4

Intermittent Clouds

5

Hazy Sunshine

6

Mostly Cloudy

7

Cloudy

8

Dreary (Overcast)

11

Fog

12

Showers

13

Mostly Cloudy with Showers

14

Partly Sunny with Showers

15

Thunderstorms

16

Mostly Cloudy with Thunderstorms

17

Partly Sunny with Thunderstorms

18

Rain

19

Flurries

20

Mostly Cloudy with Flurries

21

Partly Sunny with Flurries

22

Snow

23

Mostly Cloudy with Snow

24

Ice

25

Sleet

26

Freezing Rain

29

Rain and Snow

30

Hot

31

Cold

32

Windy

33

Clear

34

Mostly Clear

35

Partly Cloudy

36

Intermittent Clouds

37

Hazy Moonlight

38

Mostly Cloudy

39

Partly Cloudy with Showers

40

Mostly Cloudy with Showers

41

Partly Cloudy with Thunderstorms

42

Mostly Cloudy with Thunderstorms

43

Mostly Cloudy with Flurries

44

Mostly Cloudy with Snow

JsonFormat

Desired format of the response. Only json format is supported.

Value Description
json

The JavaScript Object Notation Data Interchange Format

SunGlare

The sun-glare driving hazard at a single waypoint, returned as WaypointForecast.sunGlare. Reports a glareIndex from 0 to 100 measuring the intensity of glare a driver would experience at the waypoint, together with the calculatedVehicleHeading used to compute it - the heading is either the value supplied for the waypoint in the request or, if none was supplied, one inferred from the neighboring waypoints.

Name Type Description
calculatedVehicleHeading

integer (int32)

The vehicle heading used to compute glareIndex, in azimuth degrees from 0° (true North) to 359°, measured clockwise - east is 90°, south is 180°, west is 270°. If a heading was supplied for the waypoint in the request, that value is echoed back; otherwise the service calculates one from the headings of the neighboring waypoints when available.

glareIndex

integer (int32)

An index from 0 to 100 indicating the intensity of sun glare for a driver at the waypoint, given calculatedVehicleHeading and the position of the sun. Values of 50 and above can be hazardous for some drivers; 100 indicates driving directly into the sun under clear conditions.

UnitType

An integer value associated with the type of unit being displayed. For example, 17 for Celsius, 18 for Fahrenheit. Can be used for unit translation. For more information, see Weather services in Azure Maps.

Value Description
0

feet

1

inches

2

miles

3

millimeter

4

centimeter

5

meter

6

kilometer

7

kilometersPerHour

8

knots

9

milesPerHour

10

metersPerSecond

11

hectoPascals

12

inchesOfMercury

13

kiloPascals

14

millibars

15

millimetersOfMercury

16

poundsPerSquareInch

17

Celsius

18

Fahrenheit

19

kelvin

20

percent

21

float

22

integer

31

MicrogramsPerCubicMeterOfAir

WaypointForecast

The detailed forecast for one waypoint along a road route, returned as one entry per requested waypoint in WeatherAlongRouteResult.waypoints (same order as the waypoints supplied in the request). Reports the conditions at that location: a representative iconCode and shortPhrase, whether it is day or night, cloud cover, temperature, wind and wind-gust details, precipitation type and intensity, a lightning-strike count, the sun glare hazard for the driver, the WeatherHazards aggregated at the waypoint, and any free-form hazard notifications.

Name Type Description
cloudCover

integer (int32)

The percentage of the sky covered by clouds at this waypoint, from 0 (clear skies) to 100 (completely overcast). May be NULL.

hazards

WeatherHazards

The aggregated weather hazards at this waypoint - maxHazardIndex gives the worst hazard's severity on the 0-4 scale, and hazardDetails enumerates the specific hazards (heavy rain, snow, ice, lightning, sun glare, severe weather warnings, and so on) detected at the waypoint. Uses the same shape as WeatherAlongRouteSummary.hazards, but scoped to this single waypoint instead of the entire route.

iconCode

IconCode

The representative weather icon code for this waypoint. The numeric value corresponds to an Azure Maps weather icon - for the complete list, see Weather services in Azure Maps.

isDayTime

boolean

true if it is daytime at this waypoint at the forecast time; false if it is nighttime.

lightningCount

integer (int32)

The number of lightning strikes expected near this waypoint during the forecast period. 0 indicates no lightning activity; higher values indicate more strikes, which can be used as a proxy for thunderstorm intensity.

notifications

WeatherNotification[]

Free-form hazard notifications relevant to this waypoint - each WeatherNotification carries a hazard code, severity, and short descriptive phrase. Empty when no notifications apply.

precipitation

WeatherAlongRoutePrecipitation

The expected precipitation at this waypoint - radar reflectivity (dbz) measuring intensity, plus the precipitation type (rain, snow, ice, hail, or mix).

shortPhrase

string

A brief, displayable phrase describing the forecasted weather conditions at this waypoint - for example, Mostly cloudy or Light rain. Returned in the language specified in the request.

sunGlare

SunGlare

The sun-glare driving hazard at this waypoint. Reports a glare index from 0 to 100 along with the vehicle heading used to compute it, where 50 and above can be hazardous and 100 indicates driving directly into the sun under clear conditions.

temperature

WeatherValue

The forecasted air temperature at this waypoint, in degrees Celsius (°C) or Fahrenheit (°F), depending on the unit specified in the request.

wind

WindDetails

The forecasted wind speed and direction at this waypoint. Speed is in kilometers per hour (km/h) or miles per hour (mph) depending on the unit specified in the request; direction is in azimuth degrees, measured clockwise from true North (0° = N, 90° = E, 180° = S, 270° = W).

windGust

WindDetails

The forecasted maximum short-burst wind-gust speed and direction at this waypoint, using the same units and azimuth convention as wind. Wind gusts are brief spikes in wind speed that can affect activities such as driving high-profile vehicles, aviation, and sailing.

WeatherAlongRoutePrecipitation

The expected precipitation at a single waypoint along the route, returned as WaypointForecast.precipitation. Reports the forecast intensity as radar reflectivity (dbz) together with the precipitation type (rain, snow, ice, hail, or mix). A dbz of 0 indicates no precipitation, in which case type may still be returned to indicate the precipitation type that would occur if any fell at the waypoint (for example, snow during cold weather).

Name Type Description
dbz

number (double)

Forecasted radar reflectivity in decibels relative to Z (dBZ), used as a measure of precipitation intensity. Values range from 0.0 to 100.0; higher values indicate heavier precipitation, and 0.0 indicates no precipitation.

type

string

The type of precipitation expected at the waypoint - one of RAIN, HAIL, SNOW, ICE, or MIX.

WeatherAlongRouteResult

The response returned by the Get Weather Along Route operation, providing the forecast for a sequence of waypoints along a road route. Includes a top-level summary with the highest hazard index across the route and a representative weather icon, plus a waypoints array containing one detailed forecast per requested waypoint - cloud cover, temperature, wind, precipitation, lightning count, sun glare, hazards, and notifications.

Name Type Description
summary

WeatherAlongRouteSummary

A high-level overview of conditions across the entire route - a representative weather iconCode and the maximum hazard index encountered at any waypoint - useful for surfacing a single route-level status.

waypoints

WaypointForecast[]

The per-waypoint forecasts, returned in the same order as the waypoints supplied in the request (one entry per waypoint). Each WaypointForecast reports cloud cover, weather hazards, lightning count, hazard notifications, precipitation type and intensity, sun glare, temperature, and wind details for its location.

WeatherAlongRouteSummary

The route-level summary on WeatherAlongRouteResult.summary, giving a single high-level snapshot of conditions across the entire route. Includes a representative weather iconCode for the route and an aggregated hazards block reporting the maximum hazard index and the specific hazard types encountered at any waypoint. Use this when a single route-level indicator is needed; for per-waypoint detail, use WeatherAlongRouteResult.waypoints.

Name Type Description
hazards

WeatherHazards

The aggregated weather hazards across all waypoints on the route - maxHazardIndex reports the highest severity encountered at any waypoint and hazardDetails enumerates the specific hazard types (heavy rain, snow, ice, lightning, severe weather warnings, and so on) detected anywhere along the route.

iconCode

IconCode

The representative weather icon code for the route as a whole. The numeric value corresponds to an Azure Maps weather icon - for the complete list, see Weather services in Azure Maps.

WeatherHazards

A summary of the significant weather hazards at a single location. The same shape is used in two places by the Get Weather Along Route response: on WeatherAlongRouteSummary.hazards, where it aggregates across the entire route (max severity at any waypoint), and on WaypointForecast.hazards, where it describes the hazards at one specific waypoint. Conveys both a top-level maxHazardIndex rating the worst hazard in scope (from 0 - no hazard - to 4 - life-threatening) and a hazardDetails array enumerating each specific hazard type encountered (rain, snow, ice, hail, sun glare, lightning, wind, and severe weather warnings such as floods, tornadoes, tsunamis, and severe thunderstorms).

Name Type Description
hazardDetails

HazardDetail[]

The individual hazards contributing to maxHazardIndex. Each HazardDetail identifies a specific hazard type (rain, snow, ice, hail, sun glare, lightning, wind, or a severe weather warning such as a flood, tornado, tsunami, or severe thunderstorm) along with its severity and a short descriptive phrase. See the HazardDetail.hazardCode documentation for the complete list of supported hazard codes.

maxHazardIndex

HazardIndex

The highest hazard-severity rating in scope - the maximum across the entire route when used on WeatherAlongRouteSummary.hazards, or the worst hazard at this specific waypoint when used on WaypointForecast.hazards. Useful for color-coding route segments or waypoint markers to indicate safety levels:

  • 0: No hazard
  • 1: Be informed, be aware
  • 2: Pay attention, be prepared
  • 3: Take action
  • 4: Life-threatening, emergency

WeatherNotification

One free-form hazard notification raised at a single waypoint along the route, returned as an entry in WaypointForecast.notifications. Each notification combines a type classifying the notification, a hazardCode identifying the specific hazard, a hazardIndex rating its severity on the 0-4 scale, and a shortPhrase suitable for display. Notifications complement WaypointForecast.hazards - the latter enumerates every active hazard at the waypoint, while notifications carries only the ones the service has flagged as worth surfacing to the driver.

Name Type Description
hazardCode

string

A language-independent code identifying the specific hazard the notification refers to. Uses the same set of values as HazardDetail.hazardCode:

  • LightRain, ModerateRain, HeavyRain
  • LightMix, ModerateMix, HeavyMix
  • LightSnow, ModerateSnow, HeavySnow
  • LightIce, ModerateIce, HeavyIce
  • Hail, LargeHail
  • SunGlare, SunGlareHigh
  • Lightning, SevereLightning
  • WindModerate, WindHigh, WindExtreme
  • FloodWarning, FlashFloodWarning
  • TornadoWarning, TsunamiWarning
  • SevereThunderstormWarning
hazardIndex

HazardIndex

The severity rating for this notification, on the same 0-4 scale used across the Get Weather Along Route response:

  • 0: No hazard
  • 1: Be informed, be aware
  • 2: Pay attention, be prepared
  • 3: Take action
  • 4: Life-threatening, emergency
shortPhrase

string

A short, displayable phrase describing the notification, returned in the language specified in the request.

type

string

A short label classifying the notification. Returned in the language specified in the request.

WeatherValue

Values for weather-related metrics such as temperature, dew point, and wind speed, presented in either metric or imperial units, as specified in the unit URI parameter. For more information, see Unit types in the article Weather services in Azure Maps.

Name Type Description
unit

string

The unit of measurement used in the return value, such as "C" for Celsius, "F" for Fahrenheit.

unitType

UnitType

An integer representing the type of unit. For example, 0 for feet, 1 for inches, 2 for miles. For a complete list, see Unit types in the article Weather services in Azure Maps.

value

number (float)

The measured value expressed in the specified unit.

WindDetails

Provides the forecasted wind speed, measured in units such as kilometers per hour (km/h) or miles per hour (mph), depending on the unit specified in the request. Also indicates the wind direction measured in azimuth degrees, starting at true North and moving clockwise. North corresponds to 0°, east to 90°, south to 180°, and west to 270°. Possible values range from 0° to 359°.

Name Type Description
direction

WindDirection

Wind direction is measured in azimuth degrees, starting at true North (0°) and moving clockwise. East corresponds to 90°, south to 180°, and west to 270°. Possible values range from 0° to 359°. This property returns an integer representing the wind direction.

speed

WeatherValue

The expected wind speed, measured in kilometers per hour (km/h) or miles per hour (mph), depending on the unit specified in the request.

WindDirection

Provides details about wind direction, including the direction in azimuth degrees and a localized abbreviation of the wind direction.

Name Type Description
degrees

integer (int32)

Wind direction is measured in azimuth degrees, starting at true North and moving clockwise. North corresponds to 0 degrees, east to 90 degrees, south to 180 degrees, and west to 270 degrees. Possible values range from 0 to 359 degrees.

localizedDescription

string

A localized abbreviation of the wind direction, returned in the language specified in the request. For example, N for North, E for East, S for South, and W for West.